---
title: "Row Grouping - Row Group Panel"
enterprise: true
framework: javascript
version: "36.1.0"
---

# Row Grouping - Row Group Panel

Use the Row Group Panel to enable users to modify the configured row group columns.

#### Enabling Row Group Panel

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "year", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "sport", enableRowGroup: true },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  rowGroupPanelShow: "always",
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Enabling Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/row-group-panel/typescript/)

## Enabling the Row Group Panel

The Row Group Panel allows users to modify which columns are grouped by using drag and drop. The panel can be enabled by setting the `rowGroupPanelShow` grid option to `"always"` or `"onlyWhenGrouping"`.

Columns also need to have `enableRowGroup` set to `true` in their column definition to be dragged into the panel.

The example above enables the panel and configures the `country` and `year` columns to be controllable by the panel:

```js
const gridOptions = {
    columnDefs: [
        { field: 'country', rowGroup: true, enableRowGroup: true },
        { field: 'year', rowGroup: true, enableRowGroup: true },
        // ...other column definitions
    ],
    // possible options: 'never', 'always', 'onlyWhenGrouping'
    rowGroupPanelShow: 'always',

    // other grid options ...
}
```

## Row Group Panel in the Side Bar

The Row Group Panel is also displayed as part of the [Columns Tool Panel](https://www.ag-grid.com/javascript-data-grid/tool-panel-columns/) in the [Side Bar](https://www.ag-grid.com/javascript-data-grid/side-bar/).

#### Side Bar Row Group Panel

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnsToolPanelModule, RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 150,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: "columns",
};

var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Side Bar Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/side-bar-row-group-panel/typescript/)

The example above enabled the [Columns Tool Panel](https://www.ag-grid.com/javascript-data-grid/tool-panel-columns/) using the following configuration:

```js
const gridOptions = {
    sideBar: 'columns',

    // other grid options ...
}
```

Refer to the [Side Bar](https://www.ag-grid.com/javascript-data-grid/side-bar/) documentation for further configuration options.

## Row Group Panel in the Toolbar

The Row Group Panel can be embedded in the [Quick Access Toolbar](https://www.ag-grid.com/javascript-data-grid/toolbar/#row-group-and-pivot-panels) using the `agRowGroupPanelToolbarItem` built-in item, configured independently of `rowGroupPanelShow`.

```js
const gridOptions = {
    toolbar: {
        items: ['agRowGroupPanelToolbarItem'],
    },

    // other grid options ...
}
```

## Prevent User Grouping from Hiding Columns

After a user applies row grouping to a column, the column is hidden. If the user removes the row grouping, the column is made visible again.

This behaviour can be configured by setting the `suppressGroupChangesColumnVisibility` grid option property to `true`, `"suppressHideOnGroup"` or `"suppressShowOnUngroup"`.

#### Keep Columns Visible

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", enableRowGroup: true },
    { field: "year", enableRowGroup: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 150,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  suppressDragLeaveHidesColumns: true,
  rowGroupPanelShow: "always",
};

function onPropertyChange() {
  const prop = (
    document.querySelector("#visibility-behaviour") as HTMLSelectElement
  ).value;
  if (prop === "true" || prop === "false") {
    gridApi!.setGridOption(
      "suppressGroupChangesColumnVisibility",
      prop === "true",
    );
  } else {
    gridApi!.setGridOption(
      "suppressGroupChangesColumnVisibility",
      prop as "suppressHideOnGroup" | "suppressShowOnUngroup",
    );
  }
}

function resetCols() {
  gridApi!.setGridOption("columnDefs", [
    { field: "country", enableRowGroup: true, hide: false },
    { field: "year", enableRowGroup: true, hide: false },
    { field: "athlete", minWidth: 180, hide: false },
    { field: "total", hide: false },
  ]);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onPropertyChange = onPropertyChange;
  (<any>window).resetCols = resetCols;
}
```

[Live example: Keep Columns Visible](https://www.ag-grid.com/examples/grouping-group-panel/keep-columns-visible/typescript/)

> **Note**
>
> When dragging a column over the row group panel, the column is considered outside of the grid and so will be hidden. This behaviour can be prevented by setting `suppressDragLeaveHidesColumns` to `true`.

The following configuration can be used to prevent the column visibility from being impacted when a user changes the row group columns:

```js
const gridOptions = {
    suppressGroupChangesColumnVisibility: true,
    // prevent columns from being hidden when dragged over the row group panel
    suppressDragLeaveHidesColumns: true,

    // other grid options ...
}
```

## Prevent Sorting

The panel displays sort indicators, and the column pills can be clicked to change their sort. This behaviour can be prevented by setting the `rowGroupPanelSuppressSort` property to `true`.

#### Prevent Panel Sorting

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 150,
  },
  autoGroupColumnDef: {
    sort: "asc",
    minWidth: 200,
  },
  rowGroupPanelShow: "always",
};

function toggle() {
  const checked = document.querySelector<HTMLInputElement>(
    "#rowGroupPanelSuppressSort",
  )!.checked;
  gridApi!.setGridOption("rowGroupPanelSuppressSort", checked);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggle = toggle;
}
```

[Live example: Prevent Panel Sorting](https://www.ag-grid.com/examples/grouping-group-panel/prevent-panel-sorting/typescript/)

The previous example demonstrates the following configuration for preventing the Row Group Panel from sorting columns:

```js
const gridOptions = {
    rowGroupPanelSuppressSort: true,

    // other grid options ...
}
```

## Prevent Changes to Group Order

The panel can be used to reorder or remove row grouping from columns. To prevent this, `groupLockGroupColumns` can be set to prevent removing or reordering columns. Providing `-1` will lock all columns, or provide a number representing the number of columns to lock.

#### Prevent Group Order Changes

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 150,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  rowGroupPanelShow: "always",
  groupLockGroupColumns: -1,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Prevent Group Order Changes](https://www.ag-grid.com/examples/grouping-group-panel/prevent-group-order-changes/typescript/)

The example above demonstrates locking the columns from their grouping being moved or removed:

```js
const gridOptions = {
    groupLockGroupColumns: -1,

    // other grid options ...
}
```


---
title: "Row Grouping - Row Group Panel"
enterprise: true
framework: angular
version: "36.1.0"
---

# Row Grouping - Row Group Panel

Use the Row Group Panel to enable users to modify the configured row group columns.

#### Enabling Row Group Panel

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [rowGroupPanelShow]="rowGroupPanelShow"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "year", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "sport", enableRowGroup: true },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Enabling Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/row-group-panel/angular)

## Enabling the Row Group Panel

The Row Group Panel allows users to modify which columns are grouped by using drag and drop. The panel can be enabled by setting the `rowGroupPanelShow` grid option to `"always"` or `"onlyWhenGrouping"`.

Columns also need to have `enableRowGroup` set to `true` in their column definition to be dragged into the panel.

The example above enables the panel and configures the `country` and `year` columns to be controllable by the panel:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [rowGroupPanelShow]="rowGroupPanelShow"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'country', rowGroup: true, enableRowGroup: true },
    { field: 'year', rowGroup: true, enableRowGroup: true },
    // ...other column definitions
];
// possible options: 'never', 'always', 'onlyWhenGrouping'
this.rowGroupPanelShow = 'always';
```

## Row Group Panel in the Side Bar

The Row Group Panel is also displayed as part of the [Columns Tool Panel](https://www.ag-grid.com/angular-data-grid/tool-panel-columns/) in the [Side Bar](https://www.ag-grid.com/angular-data-grid/side-bar/).

#### Side Bar Row Group Panel

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnsToolPanelModule, RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [sideBar]="sideBar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 150,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "columns";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Side Bar Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/side-bar-row-group-panel/angular)

The example above enabled the [Columns Tool Panel](https://www.ag-grid.com/angular-data-grid/tool-panel-columns/) using the following configuration:

```ts
<ag-grid-angular
    [sideBar]="sideBar"
    /* other grid options ... */ />

this.sideBar = 'columns';
```

Refer to the [Side Bar](https://www.ag-grid.com/angular-data-grid/side-bar/) documentation for further configuration options.

## Row Group Panel in the Toolbar

The Row Group Panel can be embedded in the [Quick Access Toolbar](https://www.ag-grid.com/angular-data-grid/toolbar/#row-group-and-pivot-panels) using the `agRowGroupPanelToolbarItem` built-in item, configured independently of `rowGroupPanelShow`.

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    items: ['agRowGroupPanelToolbarItem'],
};
```

## Prevent User Grouping from Hiding Columns

After a user applies row grouping to a column, the column is hidden. If the user removes the row grouping, the column is made visible again.

This behaviour can be configured by setting the `suppressGroupChangesColumnVisibility` grid option property to `true`, `"suppressHideOnGroup"` or `"suppressShowOnUngroup"`.

#### Keep Columns Visible

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label>
        <span>suppressGroupChangesColumnVisibility:</span>
        <select id="visibility-behaviour" (change)="onPropertyChange()">
          <option value="false">false</option>
          <option value="true">true</option>
          <option value="suppressHideOnGroup">"suppressHideOnGroup"</option>
          <option value="suppressShowOnUngroup">"suppressShowOnUngroup"</option>
        </select>
      </label>
      <button (click)="resetCols()">Reset Column Visibility</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [suppressDragLeaveHidesColumns]="true"
      [rowGroupPanelShow]="rowGroupPanelShow"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "country", enableRowGroup: true },
    { field: "year", enableRowGroup: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 150,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onPropertyChange() {
    const prop = (
      document.querySelector("#visibility-behaviour") as HTMLSelectElement
    ).value;
    if (prop === "true" || prop === "false") {
      this.gridApi.setGridOption(
        "suppressGroupChangesColumnVisibility",
        prop === "true",
      );
    } else {
      this.gridApi.setGridOption(
        "suppressGroupChangesColumnVisibility",
        prop as "suppressHideOnGroup" | "suppressShowOnUngroup",
      );
    }
  }

  resetCols() {
    this.gridApi.setGridOption("columnDefs", [
      { field: "country", enableRowGroup: true, hide: false },
      { field: "year", enableRowGroup: true, hide: false },
      { field: "athlete", minWidth: 180, hide: false },
      { field: "total", hide: false },
    ]);
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Keep Columns Visible](https://www.ag-grid.com/examples/grouping-group-panel/keep-columns-visible/angular)

> **Note**
>
> When dragging a column over the row group panel, the column is considered outside of the grid and so will be hidden. This behaviour can be prevented by setting `suppressDragLeaveHidesColumns` to `true`.

The following configuration can be used to prevent the column visibility from being impacted when a user changes the row group columns:

```ts
<ag-grid-angular
    [suppressGroupChangesColumnVisibility]="suppressGroupChangesColumnVisibility"
    [suppressDragLeaveHidesColumns]="suppressDragLeaveHidesColumns"
    /* other grid options ... */ />

this.suppressGroupChangesColumnVisibility = true;
// prevent columns from being hidden when dragged over the row group panel
this.suppressDragLeaveHidesColumns = true;
```

## Prevent Sorting

The panel displays sort indicators, and the column pills can be clicked to change their sort. This behaviour can be prevented by setting the `rowGroupPanelSuppressSort` property to `true`.

#### Prevent Panel Sorting

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label>
        <span>rowGroupPanelSuppressSort:</span>
        <input
          type="checkbox"
          id="rowGroupPanelSuppressSort"
          (click)="toggle()"
        />
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [rowGroupPanelShow]="rowGroupPanelShow"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 150,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    sort: "asc",
    minWidth: 200,
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  toggle() {
    const checked = document.querySelector<HTMLInputElement>(
      "#rowGroupPanelSuppressSort",
    )!.checked;
    this.gridApi.setGridOption("rowGroupPanelSuppressSort", checked);
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Prevent Panel Sorting](https://www.ag-grid.com/examples/grouping-group-panel/prevent-panel-sorting/angular)

The previous example demonstrates the following configuration for preventing the Row Group Panel from sorting columns:

```ts
<ag-grid-angular
    [rowGroupPanelSuppressSort]="rowGroupPanelSuppressSort"
    /* other grid options ... */ />

this.rowGroupPanelSuppressSort = true;
```

## Prevent Changes to Group Order

The panel can be used to reorder or remove row grouping from columns. To prevent this, `groupLockGroupColumns` can be set to prevent removing or reordering columns. Providing `-1` will lock all columns, or provide a number representing the number of columns to lock.

#### Prevent Group Order Changes

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [rowGroupPanelShow]="rowGroupPanelShow"
    [groupLockGroupColumns]="groupLockGroupColumns"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 150,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  groupLockGroupColumns = -1;
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Prevent Group Order Changes](https://www.ag-grid.com/examples/grouping-group-panel/prevent-group-order-changes/angular)

The example above demonstrates locking the columns from their grouping being moved or removed:

```ts
<ag-grid-angular
    [groupLockGroupColumns]="groupLockGroupColumns"
    /* other grid options ... */ />

this.groupLockGroupColumns = -1;
```


---
title: "Row Grouping - Row Group Panel"
enterprise: true
framework: react
version: "36.1.0"
---

# Row Grouping - Row Group Panel

Use the Row Group Panel to enable users to modify the configured row group columns.

#### Enabling Row Group Panel

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "year", rowGroup: true, enableRowGroup: true, hide: true },
    { field: "sport", enableRowGroup: true },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            rowGroupPanelShow={"always"}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Enabling Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/row-group-panel/reactFunctionalTs)

## Enabling the Row Group Panel

The Row Group Panel allows users to modify which columns are grouped by using drag and drop. The panel can be enabled by setting the `rowGroupPanelShow` grid option to `"always"` or `"onlyWhenGrouping"`.

Columns also need to have `enableRowGroup` set to `true` in their column definition to be dragged into the panel.

The example above enables the panel and configures the `country` and `year` columns to be controllable by the panel:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'country', rowGroup: true, enableRowGroup: true },
    { field: 'year', rowGroup: true, enableRowGroup: true },
    // ...other column definitions
]);
// possible options: 'never', 'always', 'onlyWhenGrouping'
const rowGroupPanelShow = 'always';

<AgGridReact
    columnDefs={columnDefs}
    rowGroupPanelShow={rowGroupPanelShow}
/>
```

## Row Group Panel in the Side Bar

The Row Group Panel is also displayed as part of the [Columns Tool Panel](https://www.ag-grid.com/react-data-grid/tool-panel-columns/) in the [Side Bar](https://www.ag-grid.com/react-data-grid/side-bar/).

#### Side Bar Row Group Panel

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnsToolPanelModule, RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total", enableValue: true, aggFunc: "sum" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 150,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            sideBar={"columns"}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Side Bar Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/side-bar-row-group-panel/reactFunctionalTs)

The example above enabled the [Columns Tool Panel](https://www.ag-grid.com/react-data-grid/tool-panel-columns/) using the following configuration:

```jsx
const sideBar = 'columns';

<AgGridReact sideBar={sideBar} />
```

Refer to the [Side Bar](https://www.ag-grid.com/react-data-grid/side-bar/) documentation for further configuration options.

## Row Group Panel in the Toolbar

The Row Group Panel can be embedded in the [Quick Access Toolbar](https://www.ag-grid.com/react-data-grid/toolbar/#row-group-and-pivot-panels) using the `agRowGroupPanelToolbarItem` built-in item, configured independently of `rowGroupPanelShow`.

```jsx
const toolbar = {
    items: ['agRowGroupPanelToolbarItem'],
};

<AgGridReact toolbar={toolbar} />
```

## Prevent User Grouping from Hiding Columns

After a user applies row grouping to a column, the column is hidden. If the user removes the row grouping, the column is made visible again.

This behaviour can be configured by setting the `suppressGroupChangesColumnVisibility` grid option property to `true`, `"suppressHideOnGroup"` or `"suppressShowOnUngroup"`.

#### Keep Columns Visible

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", enableRowGroup: true },
    { field: "year", enableRowGroup: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 150,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onPropertyChange = useCallback(() => {
    const prop = (
      document.querySelector("#visibility-behaviour") as HTMLSelectElement
    ).value;
    if (prop === "true" || prop === "false") {
      gridRef.current!.api.setGridOption(
        "suppressGroupChangesColumnVisibility",
        prop === "true",
      );
    } else {
      gridRef.current!.api.setGridOption(
        "suppressGroupChangesColumnVisibility",
        prop as "suppressHideOnGroup" | "suppressShowOnUngroup",
      );
    }
  }, []);

  const resetCols = useCallback(() => {
    gridRef.current!.api.setGridOption("columnDefs", [
      { field: "country", enableRowGroup: true, hide: false },
      { field: "year", enableRowGroup: true, hide: false },
      { field: "athlete", minWidth: 180, hide: false },
      { field: "total", hide: false },
    ]);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label>
              <span>suppressGroupChangesColumnVisibility:</span>
              <select id="visibility-behaviour" onChange={onPropertyChange}>
                <option value="false">false</option>
                <option value="true">true</option>
                <option value="suppressHideOnGroup">
                  "suppressHideOnGroup"
                </option>
                <option value="suppressShowOnUngroup">
                  "suppressShowOnUngroup"
                </option>
              </select>
            </label>
            <button onClick={resetCols}>Reset Column Visibility</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              suppressDragLeaveHidesColumns={true}
              rowGroupPanelShow={"always"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Keep Columns Visible](https://www.ag-grid.com/examples/grouping-group-panel/keep-columns-visible/reactFunctionalTs)

> **Note**
>
> When dragging a column over the row group panel, the column is considered outside of the grid and so will be hidden. This behaviour can be prevented by setting `suppressDragLeaveHidesColumns` to `true`.

The following configuration can be used to prevent the column visibility from being impacted when a user changes the row group columns:

```jsx
const suppressGroupChangesColumnVisibility = true;
// prevent columns from being hidden when dragged over the row group panel
const suppressDragLeaveHidesColumns = true;

<AgGridReact
    suppressGroupChangesColumnVisibility={suppressGroupChangesColumnVisibility}
    suppressDragLeaveHidesColumns={suppressDragLeaveHidesColumns}
/>
```

## Prevent Sorting

The panel displays sort indicators, and the column pills can be clicked to change their sort. This behaviour can be prevented by setting the `rowGroupPanelSuppressSort` property to `true`.

#### Prevent Panel Sorting

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 150,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      sort: "asc",
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const toggle = useCallback(() => {
    const checked = document.querySelector<HTMLInputElement>(
      "#rowGroupPanelSuppressSort",
    )!.checked;
    gridRef.current!.api.setGridOption("rowGroupPanelSuppressSort", checked);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label>
              <span>rowGroupPanelSuppressSort:</span>
              <input
                type="checkbox"
                id="rowGroupPanelSuppressSort"
                onClick={toggle}
              />
            </label>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              rowGroupPanelShow={"always"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Prevent Panel Sorting](https://www.ag-grid.com/examples/grouping-group-panel/prevent-panel-sorting/reactFunctionalTs)

The previous example demonstrates the following configuration for preventing the Row Group Panel from sorting columns:

```jsx
const rowGroupPanelSuppressSort = true;

<AgGridReact rowGroupPanelSuppressSort={rowGroupPanelSuppressSort} />
```

## Prevent Changes to Group Order

The panel can be used to reorder or remove row grouping from columns. To prevent this, `groupLockGroupColumns` can be set to prevent removing or reordering columns. Providing `-1` will lock all columns, or provide a number representing the number of columns to lock.

#### Prevent Group Order Changes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "athlete", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 150,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            rowGroupPanelShow={"always"}
            groupLockGroupColumns={-1}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Prevent Group Order Changes](https://www.ag-grid.com/examples/grouping-group-panel/prevent-group-order-changes/reactFunctionalTs)

The example above demonstrates locking the columns from their grouping being moved or removed:

```jsx
const groupLockGroupColumns = -1;

<AgGridReact groupLockGroupColumns={groupLockGroupColumns} />
```


---
title: "Row Grouping - Row Group Panel"
enterprise: true
framework: vue
version: "36.1.0"
---

# Row Grouping - Row Group Panel

Use the Row Group Panel to enable users to modify the configured row group columns.

#### Enabling Row Group Panel

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :rowGroupPanelShow="rowGroupPanelShow"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, enableRowGroup: true, hide: true },
      { field: "year", rowGroup: true, enableRowGroup: true, hide: true },
      { field: "sport", enableRowGroup: true },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowGroupPanelShow,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Enabling Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/row-group-panel/vue3)

## Enabling the Row Group Panel

The Row Group Panel allows users to modify which columns are grouped by using drag and drop. The panel can be enabled by setting the `rowGroupPanelShow` grid option to `"always"` or `"onlyWhenGrouping"`.

Columns also need to have `enableRowGroup` set to `true` in their column definition to be dragged into the panel.

The example above enables the panel and configures the `country` and `year` columns to be controllable by the panel:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :rowGroupPanelShow="rowGroupPanelShow"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'country', rowGroup: true, enableRowGroup: true },
    { field: 'year', rowGroup: true, enableRowGroup: true },
    // ...other column definitions
];
// possible options: 'never', 'always', 'onlyWhenGrouping'
this.rowGroupPanelShow = 'always';
```

## Row Group Panel in the Side Bar

The Row Group Panel is also displayed as part of the [Columns Tool Panel](https://www.ag-grid.com/vue-data-grid/tool-panel-columns/) in the [Side Bar](https://www.ag-grid.com/vue-data-grid/side-bar/).

#### Side Bar Row Group Panel

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnsToolPanelModule, RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :sideBar="sideBar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
      { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
      { field: "athlete", minWidth: 180 },
      { field: "total", enableValue: true, aggFunc: "sum" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 150,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "columns",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Side Bar Row Group Panel](https://www.ag-grid.com/examples/grouping-group-panel/side-bar-row-group-panel/vue3)

The example above enabled the [Columns Tool Panel](https://www.ag-grid.com/vue-data-grid/tool-panel-columns/) using the following configuration:

```ts
<ag-grid-vue
    :sideBar="sideBar"
    /* other grid options ... */>
</ag-grid-vue>

this.sideBar = 'columns';
```

Refer to the [Side Bar](https://www.ag-grid.com/vue-data-grid/side-bar/) documentation for further configuration options.

## Row Group Panel in the Toolbar

The Row Group Panel can be embedded in the [Quick Access Toolbar](https://www.ag-grid.com/vue-data-grid/toolbar/#row-group-and-pivot-panels) using the `agRowGroupPanelToolbarItem` built-in item, configured independently of `rowGroupPanelShow`.

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    items: ['agRowGroupPanelToolbarItem'],
};
```

## Prevent User Grouping from Hiding Columns

After a user applies row grouping to a column, the column is hidden. If the user removes the row grouping, the column is made visible again.

This behaviour can be configured by setting the `suppressGroupChangesColumnVisibility` grid option property to `true`, `"suppressHideOnGroup"` or `"suppressShowOnUngroup"`.

#### Keep Columns Visible

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label>
          <span>suppressGroupChangesColumnVisibility:</span>
          <select id="visibility-behaviour" v-on:change="onPropertyChange()">
            <option value="false">false</option>
            <option value="true">true</option>
            <option value="suppressHideOnGroup">"suppressHideOnGroup"</option>
            <option value="suppressShowOnUngroup">"suppressShowOnUngroup"</option>
          </select>
        </label>
        <button v-on:click="resetCols()">Reset Column Visibility</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :autoGroupColumnDef="autoGroupColumnDef"
        :suppressDragLeaveHidesColumns="true"
        :rowGroupPanelShow="rowGroupPanelShow"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", enableRowGroup: true },
      { field: "year", enableRowGroup: true },
      { field: "athlete", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 150,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    function onPropertyChange() {
      const prop = (
        document.querySelector("#visibility-behaviour") as HTMLSelectElement
      ).value;
      if (prop === "true" || prop === "false") {
        gridApi.value!.setGridOption(
          "suppressGroupChangesColumnVisibility",
          prop === "true",
        );
      } else {
        gridApi.value!.setGridOption(
          "suppressGroupChangesColumnVisibility",
          prop as "suppressHideOnGroup" | "suppressShowOnUngroup",
        );
      }
    }
    function resetCols() {
      gridApi.value!.setGridOption("columnDefs", [
        { field: "country", enableRowGroup: true, hide: false },
        { field: "year", enableRowGroup: true, hide: false },
        { field: "athlete", minWidth: 180, hide: false },
        { field: "total", hide: false },
      ]);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowGroupPanelShow,
      rowData,
      onGridReady,
      onPropertyChange,
      resetCols,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Keep Columns Visible](https://www.ag-grid.com/examples/grouping-group-panel/keep-columns-visible/vue3)

> **Note**
>
> When dragging a column over the row group panel, the column is considered outside of the grid and so will be hidden. This behaviour can be prevented by setting `suppressDragLeaveHidesColumns` to `true`.

The following configuration can be used to prevent the column visibility from being impacted when a user changes the row group columns:

```ts
<ag-grid-vue
    :suppressGroupChangesColumnVisibility="suppressGroupChangesColumnVisibility"
    :suppressDragLeaveHidesColumns="suppressDragLeaveHidesColumns"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressGroupChangesColumnVisibility = true;
// prevent columns from being hidden when dragged over the row group panel
this.suppressDragLeaveHidesColumns = true;
```

## Prevent Sorting

The panel displays sort indicators, and the column pills can be clicked to change their sort. This behaviour can be prevented by setting the `rowGroupPanelSuppressSort` property to `true`.

#### Prevent Panel Sorting

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label>
          <span>rowGroupPanelSuppressSort:</span>
          <input type="checkbox" id="rowGroupPanelSuppressSort" v-on:click="toggle()">
          </label>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :autoGroupColumnDef="autoGroupColumnDef"
          :rowGroupPanelShow="rowGroupPanelShow"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", enableRowGroup: true, rowGroup: true, hide: true },
      { field: "year", enableRowGroup: true, rowGroup: true, hide: true },
      { field: "athlete", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 150,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      sort: "asc",
      minWidth: 200,
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    function toggle() {
      const checked = document.querySelector<HTMLInputElement>(
        "#rowGroupPanelSuppressSort",
      )!.checked;
      gridApi.value!.setGridOption("rowGroupPanelSuppressSort", checked);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowGroupPanelShow,
      rowData,
      onGridReady,
      toggle,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Prevent Panel Sorting](https://www.ag-grid.com/examples/grouping-group-panel/prevent-panel-sorting/vue3)

The previous example demonstrates the following configuration for preventing the Row Group Panel from sorting columns:

```ts
<ag-grid-vue
    :rowGroupPanelSuppressSort="rowGroupPanelSuppressSort"
    /* other grid options ... */>
</ag-grid-vue>

this.rowGroupPanelSuppressSort = true;
```

## Prevent Changes to Group Order

The panel can be used to reorder or remove row grouping from columns. To prevent this, `groupLockGroupColumns` can be set to prevent removing or reordering columns. Providing `-1` will lock all columns, or provide a number representing the number of columns to lock.

#### Prevent Group Order Changes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, RowGroupingPanelModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowGroupingModule,
  RowGroupingPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :rowGroupPanelShow="rowGroupPanelShow"
      :groupLockGroupColumns="groupLockGroupColumns"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      { field: "year", rowGroup: true, hide: true },
      { field: "athlete", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 150,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const groupLockGroupColumns = ref(-1);
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowGroupPanelShow,
      groupLockGroupColumns,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Prevent Group Order Changes](https://www.ag-grid.com/examples/grouping-group-panel/prevent-group-order-changes/vue3)

The example above demonstrates locking the columns from their grouping being moved or removed:

```ts
<ag-grid-vue
    :groupLockGroupColumns="groupLockGroupColumns"
    /* other grid options ... */>
</ag-grid-vue>

this.groupLockGroupColumns = -1;
```
